(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('html2canvas'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngx-capture', ['exports', '@angular/core', 'html2canvas', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-capture'] = {}, global.ng.core, global.html2canvas, global.rxjs, global.rxjs.operators));
}(this, (function (exports, i0, html2canvas, rxjs, operators) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var html2canvas__default = /*#__PURE__*/_interopDefaultLegacy(html2canvas);

    var NgxCaptureService = /** @class */ (function () {
        function NgxCaptureService() {
        }
        NgxCaptureService.prototype.getImage = function (screen, fullCapture, cropDimensions) {
            var options = {
                logging: false
            };
            if (!fullCapture && cropDimensions.width > 10 && cropDimensions.height > 10) {
                options = Object.assign(Object.assign({}, options), cropDimensions);
            }
            else if (!fullCapture) {
                return rxjs.of(null);
            }
            return rxjs.from(html2canvas__default['default'](screen, options).then(function (canv) {
                var img = canv.toDataURL('image/png');
                return img;
            }, function (err) {
                throw new Error(err);
            }).catch(function (res) {
                throw new Error(res);
            }));
        };
        // TODO
        NgxCaptureService.prototype.downloadImage = function (img) {
            // this.canvas.nativeElement.src = img;
            // this.downloadLink.nativeElement.href = img;
            // this.downloadLink.nativeElement.download = 'test.png';
            // this.downloadLink.nativeElement.click();
        };
        return NgxCaptureService;
    }());
    NgxCaptureService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgxCaptureService_Factory() { return new NgxCaptureService(); }, token: NgxCaptureService, providedIn: "root" });
    NgxCaptureService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgxCaptureService.ctorParameters = function () { return []; };

    var NgxCaptureComponent = /** @class */ (function () {
        function NgxCaptureComponent(captureService) {
            this.captureService = captureService;
            this.resultImage = new i0.EventEmitter();
            this.isDrawing = false;
            this.cropDimensions = {
                x: 0,
                y: 0,
                width: 0,
                height: 0
            };
            this.mouse = {
                x: 0,
                y: 0,
                startX: 0,
                startY: 0
            };
            this.destroy$ = new rxjs.Subject();
        }
        NgxCaptureComponent.prototype.ngOnInit = function () {
            var _this = this;
            // if (!this.captureZone) {
            //   console.warn('"captureZone" is not set');
            //   return;
            // }
            setTimeout(function () {
                _this.rect = _this.rectangle.nativeElement;
                _this.captureZone = _this.overlay.nativeElement;
                _this.captureZone.onmousedown = function (e) { return _this.startCapture(e); };
                _this.captureZone.onmousemove = function (e) { return _this.drawRect(e); };
                _this.captureZone.onmouseup = function () { return _this.endCapture(); };
            }, 2000);
        };
        NgxCaptureComponent.prototype.setRectangle = function () {
            this.rect.style.left = this.cropDimensions.x + 'px';
            this.rect.style.top = this.cropDimensions.y + 'px';
            this.rect.style.width = this.cropDimensions.width + 'px';
            this.rect.style.height = this.cropDimensions.height + 'px';
        };
        NgxCaptureComponent.prototype.startCapture = function (e) {
            this.setMousePosition(e);
            this.isDrawing = true;
            this.mouse.startX = this.mouse.x;
            this.mouse.startY = this.mouse.y;
            this.cropDimensions = {
                x: this.mouse.x,
                y: this.mouse.y,
                width: 0,
                height: 0,
            };
            this.setRectangle();
            this.captureZone.style.cursor = 'crosshair';
        };
        NgxCaptureComponent.prototype.drawRect = function (e) {
            if (this.isDrawing) {
                this.setMousePosition(e);
                this.cropDimensions = {
                    x: (this.mouse.x - this.mouse.startX < 0) ? this.mouse.x : this.mouse.startX,
                    y: (this.mouse.y - this.mouse.startY < 0) ? this.mouse.y : this.mouse.startY,
                    width: Math.abs(this.mouse.x - this.mouse.startX),
                    height: Math.abs(this.mouse.y - this.mouse.startY),
                };
                this.setRectangle();
            }
        };
        NgxCaptureComponent.prototype.setMousePosition = function (e) {
            // tslint:disable-next-line: deprecation
            var ev = e || window.event; // Moz || IE
            if (ev.pageX) { // Moz
                this.mouse.x = ev.pageX + window.pageXOffset;
                this.mouse.y = ev.pageY + window.pageYOffset;
            }
            else if (ev.clientX) { // IE
                this.mouse.x = ev.clientX + document.body.scrollLeft;
                this.mouse.y = ev.clientY + document.body.scrollTop;
            }
        };
        NgxCaptureComponent.prototype.endCapture = function () {
            var _this = this;
            this.captureZone.style.cursor = 'default';
            this.isDrawing = false;
            this.captureService
                .getImage(this.target, false, this.cropDimensions)
                .pipe(operators.take(1), operators.tap(function (img) {
                _this.resultImage.emit(img);
            })).subscribe();
            this.cropDimensions = {
                x: 0,
                y: 0,
                width: 0,
                height: 0
            };
            this.setRectangle();
        };
        return NgxCaptureComponent;
    }());
    NgxCaptureComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-capture',
                    template: "\n  <ng-content></ng-content>\n  <div class=\"overlay\" #over>\n    <div class=\"rectangle\" #rect></div>\n  </div>\n  ",
                    styles: [".overlay{background-color:hsla(0,0%,80%,.1);height:100vh;left:0;position:absolute;top:0;width:100vw}.rectangle{border:1px solid red;position:absolute}"]
                },] }
    ];
    NgxCaptureComponent.ctorParameters = function () { return [
        { type: NgxCaptureService }
    ]; };
    NgxCaptureComponent.propDecorators = {
        rectangle: [{ type: i0.ViewChild, args: ['rect', { static: true },] }],
        overlay: [{ type: i0.ViewChild, args: ['over', { static: true },] }],
        target: [{ type: i0.Input }],
        resultImage: [{ type: i0.Output }]
    };

    var NgxCaptureModule = /** @class */ (function () {
        function NgxCaptureModule() {
        }
        return NgxCaptureModule;
    }());
    NgxCaptureModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgxCaptureComponent],
                    imports: [],
                    exports: [NgxCaptureComponent],
                    schemas: [i0.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    /*
     * Public API Surface of ngx-capture
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxCaptureComponent = NgxCaptureComponent;
    exports.NgxCaptureModule = NgxCaptureModule;
    exports.NgxCaptureService = NgxCaptureService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-capture.umd.js.map
